package session.destory.controller;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

@Controller
public class LoginController {

	@RequestMapping(value = "/login.html", method = RequestMethod.GET)
	public ModelAndView login(ModelAndView mav, @RequestParam(required = false) String error) {
		String message = "";
		
		// 에러 유형 처리
		if ("badCredentials".equals(error)) {
			message = "아이디 또는 비밀번호가 일치하지 않습니다.";
		} else if ("credentialsExpired".equals(error)) {
			message = "만료된 계정입니다.";
		} else if ("accountLocked".equals(error)) {
			message = "잠긴 계정입니다.";
		} else if ("accountDisabled".equals(error)) {
			message = "사용 정지된 계정입니다.";
		}
		
		mav.addObject("message", message);
		
		return mav;
	}

}
