package session.destory.dao.impl;

import java.util.List;

import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;

import session.destory.dao.AbstractHibernateDao;
import session.destory.dao.LoginHistoryDao;
import session.destory.entity.LoginHistory;
import session.destory.entity.User;
import session.destory.util.ObjectMap;

@Repository("loginHistoryDao")
public class LoginHistoryDaoImpl extends AbstractHibernateDao<LoginHistory> implements LoginHistoryDao {

	public LoginHistoryDaoImpl() {
		super(LoginHistory.class);
	}

	@Override
	public List<LoginHistory> findByMap(ObjectMap om) {
		DetachedCriteria c = DetachedCriteria.forClass(getClazz());

		User user = (User) om.get("user");
		if (user != null) {
			c.add(Restrictions.eq("user", user));
		}
		
		c.addOrder(Order.desc("seq"));

		return super.list(c);
	}

}
