package session.destory.security;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationListener;
import org.springframework.security.core.context.SecurityContext;
import org.springframework.security.core.session.SessionDestroyedEvent;

import session.destory.entity.LoginHistory;
import session.destory.service.LoginHistoryService;

public class SessionDestoryListener implements ApplicationListener<SessionDestroyedEvent> {

	private LoginHistoryService loginHistoryService;

	@Autowired
	public void setLoginHistoryService(LoginHistoryService loginHistoryService) {
		this.loginHistoryService = loginHistoryService;
	}

	@Override
	public void onApplicationEvent(SessionDestroyedEvent event) {

		List<SecurityContext> contexts = event.getSecurityContexts();
		if (contexts.isEmpty() == false) {
			for (SecurityContext ctx : contexts) {
				LoginToken loginToken = (LoginToken) ctx.getAuthentication()
					.getPrincipal();
				// login history
				LoginHistory loginHistory = loginToken.getHistory();
				loginHistory.setLogoutDate(new Date());
				// update
				loginHistoryService.modify(loginHistory);
			}
		}

	}

}