package session.destory.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import session.destory.dao.LoginHistoryDao;
import session.destory.entity.LoginHistory;
import session.destory.security.LoginToken;
import session.destory.service.LoginHistoryService;
import session.destory.util.ObjectMap;

@Service("loginHistoryService")
public class LoginHistoryServiceImpl implements LoginHistoryService {

	@Autowired
	private LoginHistoryDao loginHistoryDao;

	@Override
	public List<LoginHistory> inquire() {
		ObjectMap om = new ObjectMap();
		return inquire(om);
	}

	@Override
	public List<LoginHistory> inquire(ObjectMap om) {
		if (om == null) {
			om = new ObjectMap();
		}

		if (om.containsKey("user") == false) {
			Authentication auth = SecurityContextHolder.getContext().getAuthentication();
			LoginToken ut = (LoginToken) auth.getPrincipal();

			om.put("user", ut.getUser());
		}

		return loginHistoryDao.findByMap(om);
	}
	
	@Override
	@Transactional
	public LoginHistory register(LoginHistory lh) {
		return loginHistoryDao.insert(lh);
	}

	@Override
	@Transactional
	public LoginHistory modify(LoginHistory lh) {
		return loginHistoryDao.update(lh);
	}
}
