package session.destory.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import session.destory.dao.UserDao;
import session.destory.entity.User;
import session.destory.security.LoginToken;
import session.destory.service.UserService;

@Service("userService")
public class UserServiceImpl implements UserService, UserDetailsService {

	@Autowired
	UserDao userDao;

	@Override
	public User inquire(String id) {
		return userDao.selectById(id);
	}

	@Override
	public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
		User user = inquire(username);
		
		if (user == null) {
			throw new UsernameNotFoundException(username);
		}

		// LoginToken 객체를 만들어서 줌.
		// 이 객체는 Authentication.getPrincipal() 으로 사용할 수 있음.
		return new LoginToken(user);
	}

}
