package session.destory.util;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Map;

public class ObjectMap extends HashMap<String, Object> {
	private static final long serialVersionUID = -4778796930751505336L;

	public ObjectMap() {
		super();
	}

	public ObjectMap(Map<String, Object> map) {
		super();
		putAll(map);
	}

	public ObjectMap(Object obj) {
		super();
		setObject(obj);
	}

	public void setObject(Object obj) {
		Field[] fields = obj.getClass().getDeclaredFields();

		for (Field field : fields) {
			field.setAccessible(true);

			try {
				put(field.getName(), field.get(obj));
			} catch (IllegalAccessException e) {
				System.out.println("error object to map [" + field.getName()
						+ "] : " + e.getMessage());
			}
		}
	}

	public String getString(String key, boolean trim) {
		String s = getString(key);

		if (s != null) {

			if (trim == false) {
				return s;
			}

			s = s.trim();

			if (s.length() == 0) {
				return null;
			}

			return s;
		}

		return null;
	}

	public String getString(String key) {
		Object o = get(key);

		if (o != null) {
			String s = String.valueOf(o);
			if (s.trim().length() > 0) {
				return s;
			} else {
				return null;
			}
		}

		return null;
	}

	public Integer getInt(String key) {
		String s = getString(key, true);

		if (s != null) {
			return Integer.parseInt(s);
		}

		return null;
	}

	public Long getLong(String key) {
		String s = getString(key, true);

		if (s != null) {
			return Long.parseLong(s);
		}

		return null;
	}

}
